login-form Sample
===

This sample shows how to configure a secure web form-based login with a simple web page UI. 
This sample uses the a web form for entering username and password credentials.

This sample uses:

* Https for encryption of traffic for login forms 
* Automatic redirection to a login page and logged out page
* Automatic use of https for login forms and http once logged in
* Self-signed certificate. You should obtain a real certificate.
* Login username and password entry via web form
* Automatic session creation and management
* Reliable logout
* Username / password validation using the "config" file-based authentication store.
* Blowfish encryption for secure password hashing

Notes:
* This sample keeps the passwords in the auth.conf. The test password was created via:

    authpass --cipher blowfish --password pass1 auth.conf example.com joshua user

* The sample is setup to use the "config" auth store which keeps the passwords in the auth.conf file.
    Set this to "system" if you wish to use passwords in the system password database (linux or macosx only).

* Session cookies are created to manage server-side session state storage and to optimize authentication.

* The sample has two regions of access. The /public URL prefix provides all the resources needed by the login
    page before the user has been authenticated.

Requirements
---
* [Download Appweb](https://embedthis.com/appweb/download.html)

To run:
---
    appweb -v

The server listens on port 8080 for HTTP traffic and 4443 for SSL. Browse to: 
 
     http://localhost:8080/

This will redirect to the login page using https (you will get a warning due to the 
self-signed certificate). Continue and you will be prompted to login. The test 
username/password is:

    joshua/pass1

Code:
---
* [appweb.conf](appweb.conf) - Appweb configuration
* [auth.conf](auth.conf) - User passwords generated by authpass
* [index.html](index.html) - Home page
* [public/login.html](public/login.html) - Login page

Documentation:
---
* [Appweb Documentation](https://embedthis.com/appweb/doc/index.html)
* [Appweb Configuration](https://embedthis.com/appweb/doc/users/configuration.html)
* [Appweb User Authentication](https://embedthis.com/appweb/doc/users/authentication.html)
